package com.njzscloud.supervisory.dict.controller;

import com.njzscloud.supervisory.dict.pojo.SysDictEntity;
import com.njzscloud.supervisory.dict.pojo.ObtainDictDataResult;
import com.njzscloud.common.core.utils.R;
import com.njzscloud.common.mp.support.PageParam;
import com.njzscloud.common.mp.support.PageResult;
import com.njzscloud.supervisory.dict.service.SysDictService;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.web.bind.annotation.*;

import java.util.List;

/**
 * 字典表
 */
@Slf4j
@RestController
@RequestMapping("/sys_dict")
@RequiredArgsConstructor
public class SysDictController {

    private final SysDictService sysDictService;

    /**
     * 新增
     *
     * @param sysDictEntity 数据
     */
    @PostMapping("/add")
    public R<?> add(@RequestBody SysDictEntity sysDictEntity) {
        sysDictService.add(sysDictEntity);
        return R.success();
    }

    /**
     * 修改
     *
     * @param sysDictEntity 数据
     */
    @PostMapping("/modify")
    public R<?> modify(@RequestBody SysDictEntity sysDictEntity) {
        sysDictService.modify(sysDictEntity);
        return R.success();
    }

    /**
     * 删除
     *
     * @param ids Ids
     */
    @PostMapping("/del")
    public R<?> del(@RequestBody List<Long> ids) {
        sysDictService.del(ids);
        return R.success();
    }

    /**
     * 详情
     *
     * @param id Id
     * @return SysDictEntity 结果
     */
    @GetMapping("/detail")
    public R<SysDictEntity> detail(@RequestParam Long id) {
        return R.success(sysDictService.detail(id));
    }

    /**
     * 分页查询
     *
     * @param sysDictEntity 筛选条件
     * @param pageParam     分页参数
     * @return PageResult&lt;SysDictEntity&gt; 分页结果
     */
    @GetMapping("/paging")
    public R<PageResult<SysDictEntity>> paging(PageParam pageParam, SysDictEntity sysDictEntity) {
        return R.success(sysDictService.paging(pageParam, sysDictEntity));
    }


    /**
     * 获取字典数据
     *
     * @param dictKey 字典标识
     */
    @GetMapping("/dict_data")
    public R<List<ObtainDictDataResult>> obtainDictData(@RequestParam String dictKey) {
        return R.success(sysDictService.obtainDictData(dictKey));
    }


}
